var c = Object.defineProperty;
var _ = (o, e, r) => e in o ? c(o, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : o[e] = r;
var t = (o, e, r) => (_(o, typeof e != "symbol" ? e + "" : e, r), r);
import * as i from "oauth4webapi";
import { ref as h, watch as n, computed as u, readonly as d } from "vue";
import { LocalStorage as l } from "./LocalStorage.js";
import "./Storage.js";
class w {
  constructor(e) {
    t(this, "_client");
    t(this, "_issuer");
    t(this, "_scope");
    t(this, "_storage");
    t(this, "_redirectUri");
    t(this, "_postLogoutRedirectUri");
    t(this, "_refreshToken", h());
    t(this, "_accessToken", h());
    t(this, "_codeVerifier", h());
    t(this, "_authorizationServer");
    /**
     * Extends the client options.
     * @param options - The options to change.
     * @example
     * ```typescript
     * const client = new OAuthClient({
     * 	url: 'https://example.com',
     * 	clientId: 'my-client-id',
     * })
     * client.extend({
     * 	scopes: 'openid profile email'
     * })
     * ```
     */
    t(this, "extend", (e) => {
      var r;
      e.url && (this._issuer = new URL(e.url), this._authorizationServer = void 0, this._refreshToken.value = void 0, this._accessToken.value = void 0, this._codeVerifier.value = void 0), e.clientId && (this._client.client_id = e.clientId), e.tokenEndpointAuthMethod && (this._client.token_endpoint_auth_method = e.tokenEndpointAuthMethod), e.scopes && (this._scope = typeof e.scopes == "string" ? e.scopes : ((r = e.scopes) == null ? void 0 : r.join(" ")) ?? ""), e.storage && (this._storage = e.storage, this._refreshToken.value = this._storage.get("refresh_token"), this._accessToken.value = void 0, this._codeVerifier.value = this._storage.get("code_verifier")), e.redirectUri && (this._redirectUri = e.redirectUri), e.postLogoutRedirectUri && (this._postLogoutRedirectUri = e.postLogoutRedirectUri);
    });
    /**
     * Initializes the client and tries to refresh the token if a refresh token is available, see {@link refreshToken}.
     * or handle the code response if a code verifier is available, see {@link handleCodeResponse}.
     * @example
     * ```typescript
     * const client = new OAuthClient({
     * 	url: 'https://example.com',
     * 	clientId: 'my-client-id',
     * })
     * await client.initialize()
     * ```
     */
    t(this, "initialize", async () => {
      if (this._authorizationServer = await i.discoveryRequest(this._issuer).then(
        (e) => i.processDiscoveryResponse(this._issuer, e)
      ), this._refreshToken.value)
        return await this.refreshToken();
      if (this._codeVerifier.value) {
        const e = new URLSearchParams(window.location.search);
        return await this.handleCodeResponse(e);
      }
      return Promise.resolve();
    });
    /**
     * Authorize the application redirecting the client to the authorization server.
     * @throws If the client is not initialized.
     * @example
     * ```typescript
     * const client = new OAuthClient({
     * 	url: 'https://example.com',
     * 	clientId: 'my-client-id',
     * })
     * await client.initialize()
     * await client.authorize()
     * ```
     */
    t(this, "authorize", async () => {
      var s;
      if (!this._authorizationServer)
        throw new Error("OAuthClient not initialized");
      this._codeVerifier.value = i.generateRandomCodeVerifier();
      const e = await i.calculatePKCECodeChallenge(
        this._codeVerifier.value
      ), r = new URL(
        ((s = this._authorizationServer) == null ? void 0 : s.authorization_endpoint) ?? `${this._issuer.toString()}/oauth2/authorize`
      );
      r.searchParams.set("client_id", this._client.client_id), r.searchParams.set("code_challenge", e), r.searchParams.set("code_challenge_method", "S256"), r.searchParams.set("redirect_uri", this._redirectUri), r.searchParams.set("response_type", "code"), r.searchParams.set("scope", this._scope), document.location.replace(r.toString());
    });
    /**
     * Handle the authorization code response.
     * @throws If the client is not initialized.
     * @param urlParams - The URL parameters.
     */
    t(this, "handleCodeResponse", async (e) => {
      if (!this._authorizationServer)
        throw new Error("OAuthClient not initialized");
      if (!this._codeVerifier.value)
        return !1;
      if (!e.has("code"))
        return this._codeVerifier.value = void 0, !1;
      const r = i.validateAuthResponse(
        this._authorizationServer,
        this._client,
        e,
        i.expectNoState
      );
      if (i.isOAuth2Error(r))
        throw this._codeVerifier.value = void 0, new Error("OAuth 2.0 redirect error");
      const s = await i.authorizationCodeGrantRequest(
        this._authorizationServer,
        this._client,
        r,
        this._redirectUri,
        this._codeVerifier.value
      );
      if (i.parseWwwAuthenticateChallenges(s))
        throw this._codeVerifier.value = void 0, new Error("www-authenticate challenges error");
      const a = await i.processAuthorizationCodeOpenIDResponse(
        this._authorizationServer,
        this._client,
        s
      );
      if (i.isOAuth2Error(a))
        throw this._codeVerifier.value = void 0, new Error("OAuth 2.0 response body error");
      return this._codeVerifier.value = void 0, this._accessToken.value = a.access_token, this._refreshToken.value = a.refresh_token, this.accessToken;
    });
    /**
     * Refresh the access token.
     * @throws If the client is not initialized.
     * @example
     * ```typescript
     * const client = new OAuthClient({
     * 	url: 'https://example.com',
     * 	clientId: 'my-client-id',
     * })
     * await client.initialize()
     * await client.refreshToken()
     * ```
     * @returns The new access token.
     */
    t(this, "refreshToken", async () => {
      if (!this._authorizationServer)
        throw new Error("OAuthClient not initialized");
      if (!this._refreshToken.value)
        return !1;
      const e = await i.refreshTokenGrantRequest(
        this._authorizationServer,
        this._client,
        this._refreshToken.value
      ), r = await i.processRefreshTokenResponse(
        this._authorizationServer,
        this._client,
        e
      );
      if (i.isOAuth2Error(r))
        throw new Error("OAuth 2.0 response body error");
      return this._accessToken.value = r.access_token, this._refreshToken.value = r.refresh_token, this.accessToken;
    });
    /**
     * Logout the user.
     * @param logoutHint - The hint to the Authorization Server about the End-User that is logging out.
     * @throws If the client is not initialized.
     * @example
     * ```typescript
     * const client = new OAuthClient({
     * 	url: 'https://example.com',
     * 	clientId: 'my-client-id',
     * })
     * await client.initialize()
     * client.logout()
     * ```
     */
    t(this, "logout", (e) => {
      var r;
      if (!this._authorizationServer)
        throw new Error("OAuthClient not initialized");
      if (this._refreshToken.value = void 0, this.loggedIn.value) {
        this._accessToken.value = void 0;
        const s = new URL(
          ((r = this._authorizationServer) == null ? void 0 : r.end_session_endpoint) ?? `${this._issuer.toString()}/oauth2/logout`
        );
        s.searchParams.set(
          "post_logout_redirect_uri",
          this._postLogoutRedirectUri
        ), e && s.searchParams.set("logout_hint", e), document.location.replace(s.toString());
      }
    });
    var r;
    this._issuer = new URL(e.url), this._client = {
      client_id: e.clientId,
      token_endpoint_auth_method: e.tokenEndpointAuthMethod ?? "none"
    }, this._scope = typeof e.scopes == "string" ? e.scopes : ((r = e.scopes) == null ? void 0 : r.join(" ")) ?? "", this._storage = e.storage ?? new l("oauth"), this._refreshToken.value = this._storage.get("refresh_token"), this._codeVerifier.value = this._storage.get("code_verifier"), this._redirectUri = e.redirectUri ?? document.location.origin, this._postLogoutRedirectUri = e.postLogoutRedirectUri ?? document.location.origin, n(this._refreshToken, (s) => {
      this._storage.set("refresh_token", s);
    }), n(this._codeVerifier, (s) => {
      this._storage.set("code_verifier", s);
    });
  }
  /**
   * Reactive value indicating whether the user is logged in.
   * @example
   * ```typescript
   * const client = new OAuthClient({
   * 	url: 'https://example.com',
   * 	clientId: 'my-client-id',
   * })
   * await client.initialize()
   * if (client.loggedIn.value) {
   * 	// User is logged in
   * }
   * ```
   */
  get loggedIn() {
    return u(() => !!this._accessToken.value);
  }
  /**
   * Reactive value indicating the access token.
   * @example
   * ```typescript
   * const client = new OAuthClient({
   * 	url: 'https://example.com',
   * 	clientId: 'my-client-id',
   * })
   * await client.initialize()
   * if (client.loggedIn.value) {
   * 	// User is logged in
   * 	console.log(client.accessToken.value)
   * }
   * ```
   */
  get accessToken() {
    return d(this._accessToken);
  }
  /**
   * Indicates whether the client has been initialized.
   * @example
   * ```typescript
   * const client = new OAuthClient({
   * 	url: 'https://example.com',
   * 	clientId: 'my-client-id',
   * })
   * if (!client.initialized) {
   * 	await client.initialize()
   * }
   * ```
   */
  get initialized() {
    return !!this._authorizationServer;
  }
}
export {
  w as OAuthClient
};
